-- All players to turn on/off view and edit of their base
commands.add_command("edit-view-base", {"cmd-edit-view-base"}, function(command)
    if command.player_index == nil then return end -- Ignore if it's not a player
    local player = game.players[command.player_index]
    local force = player.force
    if command.parameter == nil then
        player.print("To toggle friend status use: edit-view-base forceName")
        return
    end
    local target_force = game.forces[command.parameter]
    if target_force == nil then
        if command.player_index ~= nil then
            player.print("Invalid forceName")
        end
        return
    end
    if target_force.name == force.name then
        player.print("Don't try to disable your force from seeing it's own base!")
    end
    local friendSetting = not player.force.get_friend(target_force)
    player.force.set_friend(target_force, friendSetting)
    if friendSetting then
        player.print({"cmd-edit-view-base-enabled", target_force.name}) 
    else
        player.print({"cmd-edit-view-base-disabled", target_force.name}) 
    end
end)


