------------------------------------------------------------------------------------------------------------------------
-- Starting Items
------------------------------------------------------------------------------------------------------------------------
-- Items provided to the player the first time they join
PLAYER_SPAWN_START_ITEMS =
{
    player_start_items = {
        ["coal"] = 10,
        ["wood"] = 1,
        ["pistol"] = 1,
        ["firearm-magazine"] = 10,
        ["burner-mining-drill"] = 10,
        ["stone-furnace"] = 10
    },
    player_respawn_items = {
        ["pistol"] = 1,
        ["firearm-magazine"] = 10
    },

    crashed_ship = false,
    crashed_ship_resources = {
    },
    crashed_ship_wreakage = {
    },

}

PLAYER_SPAWN_START_ITEMS_SPACE_BLOCK = {
    ["coal"] = 10,
    ["stone-furnace"] = 4
}

PLAYER_SPAWN_START_ITEMS_SEABLOCK = {
    ["pistol"] = 1,
    ["coal"] = 10,
    ["stone-furnace"] = 4
}

BNO_SPAWN_CONFIG =      -- from oarc : NAUVIS_SPAWN_CONFIG
{
    -- Used to fill in area that collides with water layer, IF force grass is enabled.
    fill_tile = "grass-1",

    -- Used to fill in the moat and the liquid strip at the top of the circle if no moat.
    liquid_tile = "water",

    -- Used to circle the base. Set to nil to disable.
    tree_entity = "tree-02",

    -- Random entities to place around the base.
    random_entities = {
        {name = "big-rock", count = 5},
        {name = "huge-rock", count = 5},
        {name = "dead-grey-trunk", count = 5},
        {name = "big-sand-rock", count = 5},
    },

    -- Used to modify the size of the base.
    radius_modifier = 1,

    -- Safe Spawn Area Options
    -- The default settings here are balanced for my recommended map gen settings (close to train world).
    safe_area =
    {
        -- Safe area has no aliens
        -- This is the radius in chunks of safe area.
        safe_radius = 6,

        -- Warning area has significantly reduced aliens
        -- This is the radius in chunks of warning area.
        warn_radius = 12,

        -- 1 : X (spawners alive : spawners destroyed) in this area
        warn_reduction = 20,

        -- Danger area has slightly reduced aliens
        -- This is the radius in chunks of danger area.
        danger_radius = 24,

        -- 1 : X (spawners alive : spawners destroyed) in this area
        danger_reduction = 5,
    },

    -- Location of water strip within the spawn area (2 horizontal rows)
    -- The offset is from the TOP (NORTH) of the spawn area.
    water = {
        x_offset = -4,
        y_offset = 10,
        length = 8,
    },

    -- Location of shared power pole within the spawn area (if enabled)
    -- The offset is from the RIGHT (WEST) of the spawn area.
    shared_power_pole_position = {
        x_offset=-10,
        y_offset=0
    },

    -- Location of shared chest within the spawn area (if enabled)
    -- The offset is from the RIGHT (WEST) of the spawn area.
    shared_chest_position = {
        x_offset=-10,
        y_offset=1
    },

    -- Solid resource tiles
    -- If you are running with mods that add or change resources, you'll want to customize this.
    -- Offsets only are applicable if auto placement is disabled. Offsets are from CENTER of spawn area.
    solid_resources = {
        ["stone"] =
        {
            amount = 1200,
            size = 16,
            x_offset = -59,	
            y_offset = -38	
        },
        ["copper-ore"] =
        {
            amount = 1200,
            size = 18,
            x_offset = -59,
            y_offset = -16
        },
        ["iron-ore"] =
        {
            amount = 1500,
            size = 18,
            x_offset =-58,	
            y_offset = 8	
        },
        ["coal"] =
        {
            amount = 1200,
            size = 16,
            x_offset = -59,
            y_offset = 30
        }

    },


    -- Fluid resource patches like oil
    -- If you are running with mods that add or change resources, you'll want to customize this.
    -- The offset is from the BOTTOM (SOUTH) of the spawn area.
    fluid_resources =
    {
        ["crude-oil"] =
        {
            num_patches = 2,
            amount = 900000,
            spacing = 6, -- Spacing between each patch, only used for automatic placing.

            -- These are only used if not using automatic placing.
            -- Starting position offset (relative to bottom/south of spawn area)
            x_offset_start = -4,
            y_offset_start = -48,
            -- Additional position offsets for each new oil patch (relative to previous oil patch)
            x_offset_next = 6,
            y_offset_next = 0
        }
    },

    gleba_resources = {},

    player_spawn_offset = {x=0, y=10},
}
