require("lib/oarc_utilsX")
require("bno_config")



-- Generate the basic starter resource around a given location.
function GenerateExtraStartingResources(surface, pos)
    storage.ocfg = remote.call("oarc_mod", "get_mod_settings")
    storage.ocfg.resource_placement.random_order = false
    local kOffset=0
    -- find the next y offset under coal (the bottom resource)
    local pos_x = pos.x - 59    -- location of coal -59
    local next_y_offset = 30 + 20 + 4  -- location of coal 30
    if not storage.bno.dangOreus then
        if storage.bno.krastorio2 then
            kOffset=32
            if (storage.ocfg.spawn_general.shape == "square") then
                pos_x = pos_x-kOffset   -- and another 32 for Krastorio which is 32 larger in diameter
                log("Square base")
            elseif (storage.ocfg.spawn_general.shape == "circle") then
                pos_x = pos_x - 6
                next_y_offset = next_y_offset + 2
                log("Circle Base")
            elseif (storage.ocfg.spawn_general.shape == "octagon") then
                pos_x = pos_x - 6
                next_y_offset = next_y_offset + 2
                log("Octagon Base")
            end
            GenerateResourcePatch(surface, "kr-rare-metal-ore", 16, {x=pos_x, y=pos.y+next_y_offset}, 3000)
            next_y_offset = next_y_offset + 20 + 4
            if not storage.bno.krastorio2_resources_increased then
                for k,item in pairs(storage.ocfg.surfaces_config["nauvis"].spawn_config.solid_resources) do
                    if (item ~= "") then
                        item.amount = item.amount*4
                        item.y_offset = item.y_offset - 16   -- krastorio2 is 32 larger
                    end
                end
            end
            storage.bno.krastorio2_resources_increased=true
        end
        if storage.bno.scrap_resources then
            GenerateResourcePatch(surface, "scrap", 12, {x=pos_x, y=pos.y+next_y_offset}, 3000)
            next_y_offset = next_y_offset + 12 + 4
        end
        if storage.bno.bzlead then
            GenerateResourcePatch(surface, "lead-ore", 15, {x=pos_x, y=pos.y+next_y_offset}, 20000)
            next_y_offset = next_y_offset + 15 + 4
        end
        if storage.bno.bztitanium then
            GenerateResourcePatch(surface, "titanium-ore", 8, {x=pos_x, y=pos.y+next_y_offset}, 5000)
            next_y_offset = next_y_offset + 8 + 4
        end
        if storage.bno.scrap_resources then
            GenerateResourcePatch(surface, "scrap", 12, {x=pos_x, y=pos.y+next_y_offset}, 3000)
            next_y_offset = next_y_offset + 12 + 4
        end
    end
--    if storage.bno.dangOreus then   -- clear oil area
--        -- clear under oil patches
--        local p_data = storage.ocfg.spawn_config.resource_patches["crude-oil"]
--        local oil_patch_x=pos.x+p_data.x_offset_start
--        local oil_patch_y=pos.y+p_data.y_offset_start
--        for i=1,p_data.num_patches do
--            local entities = surface.find_entities_filtered{area = {{oil_patch_x-9, oil_patch_y-8}, {oil_patch_x+10, oil_patch_y+8}}, force = "neutral"}
--            for _, entity in pairs(entities) do
--                entity.destroy()
--            end
--            oil_patch_x=oil_patch_x+p_data.x_offset_next
--            oil_patch_y=oil_patch_y+p_data.y_offset_next
--        end
--    end

-- oarc does this now
--    -- Generate special resource patches (oil)
--    if not storage.ocfg.seablock then
--        for p_name,p_data in pairs (storage.ocfg.surfaces_config["nauvis"].spawn_config.solid_resources) do
--            local oil_patch_x=pos.x+p_data.x_offset_start
--            local oil_patch_y=pos.y+p_data.y_offset_start
--            for i=1,p_data.num_patches do
--                surface.create_entity({name=p_name, amount=p_data.amount,position={oil_patch_x, oil_patch_y}})
--                oil_patch_x=oil_patch_x+p_data.x_offset_next
--                oil_patch_y=oil_patch_y+p_data.y_offset_next
--            end
--        end
--    end
end
