function InitBNOConfig()
    storage.bno.enable_miner_decon = {} -- forces
    storage.bno.enable_miner_decon_notification = {} -- forces
    storage.bno.bno_decon_miners = {}       -- table of miners to decon on_nth_tick
--    storage.bno.enable_anti_grief =  setGlobalSetting("bno-anti-grief", ENABLE_ANTI_GRIEFING, true)
    storage.bno.starting_bot_count = setGlobalSetting("bno-num-starting-bots", "100/50") 
    -- ghost ttl is special due to a string array of numbers and multiplying by TICKS_PER_MINUTE
--    local ghost_ttl = GHOST_TIME_TO_LIVE
--    if (settings.startup["bno-anti-grief-ghost-TTL"].value ~= "use config.lua setting") then
--        ghost_ttl = tonumber(settings.startup["bno-anti-grief-ghost-TTL"].value)  * TICKS_PER_MINUTE
--    end   
--    log("Setting anti-grief ghost ttl settings to: " .. ghost_ttl/TICKS_PER_MINUTE .. " minutes")
--    storage.ocfg.ghost_ttl = ghost_ttl

    storage.bno.enable_server_write_files = true
    storage.bno.warn_biter_attack = setGlobalSetting("bno-biter-swarm-attack", true, false)

    storage.bno.warn_biter_setting = {}
    storage.bno.share_chart = {}


    storage.bno.space_block = script.active_mods["spaceblock"]
    if (storage.bno.space_block) then    -- in data stage use:  mods["spaceblock"]
        log("Space Block mod installed !")
    end
    storage.bno.easyStart=false

    -- The results of each of these can be treated as a boolean, but also contain the version number of the mod
    storage.bno.freight_forwarding  = script.active_mods["FreightForwarding"]
    storage.bno.bzlead              = script.active_mods["bzlead"]
    storage.bno.bztitanium          = script.active_mods["bztitanium"]
    storage.bno.krastorio2          = script.active_mods["Krastorio2"]
    storage.bno.seablock            = script.active_mods["SeaBlock"]
    storage.bno.lex_aircraft        = script.active_mods["lex-aircraft"]
    storage.bno.alien_module        = script.active_mods["alien-module"]
    storage.bno.LootChestPlus       = script.active_mods["LootChestPlus"]
    storage.bno.dangOreus           = script.active_mods["dangOreus"]
    storage.bno.claustorephobic     = script.active_mods["zzz-claustorephobic"]
    storage.bno.circuitissimo       = script.active_mods["circuitissimo"]
    storage.bno.brave_new_assembling_machines       = script.active_mods["brave-new-assembling-machines"]
    storage.bno.VoidBlock           = script.active_mods["VoidBlock"]
    storage.bno.stranded_block_2    = script.active_mods["stranded_block_2"]
    storage.bno.voidsnatch          = script.active_mods["void-snatch"]
    storage.bno.scrap_resources     = script.active_mods["scrap-resource"]
    storage.bno.space_age           = script.active_mods["space-age"]
    
        
--    storage.bno.forceRegenerationOfSilos = storage.bno.dangOreus

    if (storage.bno.krastorio2) then 
        storage.bno.creep_initialized=false
    end
    if storage.bno.brave_new_assembling_machines then
        storage.bno.surface_index_set=false
    end

    if storage.bno.seablock then
        storage.ocfg.gameplay.allow_moats_around_spawns = false  -- moat makes no sense for seablock
    end
    if storage.bno.freight_forwarding then storage.ocfg.frontier_rocket_silo=false end
    storage.bno.krastorio2_resources_increased = false

    if storage.bno.dangOreus then
        storage.bno.dangOreus_initialized=false
    end
end
-- Set a value either based on MOD settings or config.lua
-- only use isYesNo true if field returns "yes" and needs conversion to boolean
function setGlobalSetting(settings_startup_name, default_val, isYesNo)
    isYesNo = isYesNo or false    -- set default to false
    local tmpVal = default_val
    local settingVal = settings.startup[settings_startup_name].value
    if ((settingVal ~= "use config.lua setting")) then
        if (isYesNo) then
            tmpVal = settingVal=="yes"      -- convert Yes/No into boolean
        else
            tmpVal = settingVal
        end
    end   
    log("setGlobalSetting: " .. settings_startup_name .. ", isYesNo? " .. tostring(isYesNo) .. ", input value: " .. tostring(default_val) .. ", output value: " .. tostring(tmpVal))
    return tmpVal
end
