function BNOSwarmGroupInit()
	if (not storage.swarmGroup) then
		storage.swarmGroup = {}
	end    
end

-- Called on_tick to determine if the swarm has just started moving, and to send the ping.
-- also to remove the swarm from the stack if they don't move towards your main and when they die at your main.
function BNOCleanGPSStack()    
    if (storage.swarmGroup == nil) then
        storage.swarmGroup = {}
    end
    if (#storage.swarmGroup > 0) then
        -- Check once a second - not every tick - which is 1/60th of a second
--        for k,swarm in pairs(storage.swarmGroup) do    -- can't do this or we skip items
        for k=#storage.swarmGroup, 1, -1 do
            if (not storage.swarmGroup[k]) or (not storage.swarmGroup[k].group.valid) then
                if (storage.enable_oe_debug) then
                    log("REMOVING swarm tracking " .. k .. " they be dead")
                end
                table.remove(storage.swarmGroup,k)   -- end of swarm tracking
            else
                if (storage.swarmGroup[k]~=nil) then
                    if (storage.swarmGroup[k].group.state ~=nil) then
                        if (storage.enable_oe_debug) then
                            log  ("TICK - swarm " .. k ..":  group.command.type = " .. commandType(storage.swarmGroup[k].group.command.type) .. ", state: " .. groupState(storage.swarmGroup[k].group.state))
                        end
                        -- only do this once, for each group, and wait for them to start moving since every group will start with group_state.pathfinding.
                        -- the groups that never attack will immediately be removed from the stack
                        -- the groups that attack will eventually go to group_state.attacking_target, but first moving
                        if (storage.swarmGroup[k].group.state == defines.group_state.moving) then
                            if (not storage.swarmGroup[k].gpsSent) then
                                storage.swarmGroup[k].target_player.print(storage.swarmGroup[k].target_player.name .. ": Wave of " .. #storage.swarmGroup[k].group.members .. " biters incoming :" .. GetGPStext(storage.swarmGroup[k].startPosition), {sound=defines.print_sound.never})
                                storage.swarmGroup[k].target_player.play_sound { path = 'wave-coming' }
                                storage.swarmGroup[k].gpsSent=true   -- only send this ping once
                            end
                        end
                    end
                end
            end
        end
    end
end

function commandType(type)
    if      (type==defines.command.attack) then       
        return " attack"
    elseif  (type==defines.command.go_to_location) then
        return " go to location"
    elseif  (type==defines.command.compound) then
        return " compound"
    elseif  (type==defines.command.group) then
        return " group"
    elseif  (type==defines.command.attack_area) then
        return " attack area"
    elseif  (type==defines.command.wander) then
        return "wandering"
    elseif  (type==defines.command.flee) then
        return "flee"
    elseif  (type==defines.command.stop) then
        return "stop"
    elseif  (type==defines.command.build_base) then
        return "build base"
    else
        return "unknown"
    end
end

function groupState(state)
    if      (state==defines.group_state.gathering) then       
        return " gathering"
    elseif  (state==defines.group_state.moving) then
        return " moving"
    elseif  (state==defines.group_state.attacking_distraction) then
        return " attacking distraction"
    elseif  (state==defines.group_state.attacking_target) then
        return " attacking target"
    elseif  (state==defines.group_state.finished) then
        return " finished"
    elseif  (state==defines.group_state.pathfinding) then
        return " path finding"
    elseif  (state==defines.group_state.wandering_in_group) then
        return " wandering in group"
    else
        return "unknown"
    end
end