-- Some of this taken from Robot_and_Radar_MK2  module !
-- This is settings for new roboport called roboport-bno
---------------------------------
-- Roboport changes
---------------------------------

---------------------------------
-- Roboport BNO
---------------------------------
local sounds = require("__base__/prototypes/entity/sounds")
local item_sounds = require("__base__/prototypes/item_sounds")


roboport = data.raw.roboport["roboport"]
roboport.place_result = "roboport-bno"

roboportmain = table.deepcopy(roboport)
roboportmain.name = "roboport-bno"
data:extend({ roboportmain })

local zoneIncrease = settings.startup["bno-increase-logistics"].value

data:extend({
-- ENTITY
{
    type = "roboport",
    name = "roboport-bno",
	icon = "__brave-new-oarc__/graphics/icons/roboport-bno.png",
	localised_name = "Brave New Roboport",
	localised_description = { "entity-description.roboport-bno" },
    flags = {"placeable-player", "player-creation"},
    fast_replaceable_group = nil,
    minable = {mining_time = 0.1, result = "roboport-bno"},
    max_health = 500,
	corpse = "roboport-remnants",
	scale=.9,
    dying_explosion = "roboport-explosion",
	collision_box = {{-2.8, -1.8}, {2.8, 3.8}},
	selection_box = {{-3, -2}, {3, 4}},
    resistances =
    {
      {
        type = "fire",
        percent = 60
      },
      {
        type = "impact",
        percent = 30
      }
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      input_flow_limit = tostring(util.parse_energy(roboportmain.energy_source.input_flow_limit)*60*4) .. "W",
      buffer_capacity = tostring(util.parse_energy(roboportmain.energy_source.buffer_capacity)*4) .. "J"
    },
	energy_usage = tostring(util.parse_energy(roboportmain.energy_usage)*60*4) .. "W",
	recharge_minimum = "160MJ",
	charging_energy = "1MW",
    charge_approach_distance = 5,
	is_military_target=true,
	logistics_radius = roboportmain.logistics_radius + zoneIncrease,
	construction_radius = roboportmain.construction_radius + zoneIncrease*2,	-- to reach the large roboport-bno
	-- quadruple charging capacities
	robot_slots_count = 20,
	material_slots_count = 8,
    stationing_offset = {0, 0},
	-- quadruple charging capacities
	charging_offsets = {
		{-1.5, 1.5}, {-0.5, 1.5}, { 0.5, 1.5}, { 1.5, 1.5},
		{-1.5, 0.5}, {-0.5, 0.5}, { 0.5, 0.5}, { 1.5, 0.5},
		{-1.5,-0.5}, {-0.5,-0.5}, { 0.5,-0.5}, { 1.5,-0.5},
		{-1.5,-1.5}, {-0.5,-1.5}, { 0.5,-1.5}, { 1.5,-1.5},
	},
	base =
	{
		layers =
		{
			{
				filename = "__brave-new-oarc__/graphics/entity/roboport-bno/hr-roboport-bno-base.png",
				width = 228,
				height = 277,
				shift = util.by_pixel(2, 30.25),
				scale = 0.85
			},
			{
				filename = "__base__/graphics/entity/roboport/roboport-shadow.png",
				width = 294,
				height = 201,
				draw_as_shadow = true,
				shift = util.by_pixel(28.5, 9.25),
				scale = 0.85
			}
		}
	},
	-- Y increased Down, X increases to right
	base_patch =
	{
		filename = "__brave-new-oarc__/graphics/entity/roboport-bno/hr-roboport-bno-base-patch.png",
		priority = "medium",
		width = 138,
		height = 100,
		shift = util.by_pixel(1.5, 27),
		scale = 0.85
	},
	base_animation =
	{
		filename = "__base__/graphics/entity/roboport/roboport-base-animation.png",
		priority = "medium",
		width = 83,
		height = 59,
		frame_count = 8,
		animation_speed = 0.5,
		shift = util.by_pixel(-30.75, -86.25),
		scale = 0.85
	},
	door_animation_up =
	{
		filename = "__brave-new-oarc__/graphics/entity/roboport-bno/hr-roboport-bno-door-up.png",
		priority = "medium",
		width = 97,
		height = 38,
		frame_count = 16,
		shift = util.by_pixel(-2.25, -33.5),
		scale = 0.85
	},
	door_animation_down =
	{
		filename = "__brave-new-oarc__/graphics/entity/roboport-bno/hr-roboport-bno-door-down.png",
		priority = "medium",
		width = 97,
		height = 41,
		frame_count = 16,
		shift = util.by_pixel(-2.25, -1.75),
		scale = 0.85
	},
	recharging_animation =
	{
		filename = "__base__/graphics/entity/roboport/roboport-recharging.png",
		draw_as_glow = true,
		priority = "high",
		width = 37,
		height = 35,
		frame_count = 16,
		scale = 0.85,
		animation_speed = 0.6,
	},
	impact_category = "metal",
	open_sound = {filename = "__base__/sound/open-close/roboport-open.ogg", volume = 0.5},
	close_sound = {filename = "__base__/sound/open-close/roboport-close.ogg", volume = 0.4},
	working_sound =
	{
		sound = { filename = "__base__/sound/roboport-working.ogg", volume = 0.4 },
		max_sounds_per_type = 3,
		audible_distance_modifier = 0.75
	},
	recharging_light = {intensity = 0.2, size = 3, color = {0.5, 0.5, 1}},
	request_to_open_door_timeout = 15,
	spawn_and_station_height = 0.3,
	stationing_render_layer_swap_height = 0.87,
	
	draw_logistic_radius_visualization = true,
	draw_construction_radius_visualization = true,
	
	open_door_trigger_effect = sounds.roboport_door_open,
	close_door_trigger_effect = sounds.roboport_door_close,
	
	circuit_connector = circuit_connector_definitions["roboport"],
	circuit_wire_max_distance = default_circuit_wire_max_distance,
	
	default_available_logistic_output_signal = {type = "virtual", name = "signal-X"},
	default_total_logistic_output_signal = {type = "virtual", name = "signal-Y"},
	default_available_construction_output_signal = {type = "virtual", name = "signal-Z"},
	default_total_construction_output_signal = {type = "virtual", name = "signal-T"},
	default_roboport_count_output_signal = {type = "virtual", name = "signal-R"},
	
	water_reflection =
	{
	  pictures =
	  {
	    filename = "__base__/graphics/entity/roboport/roboport-reflection.png",
	    priority = "extra-high",
	    width = 28,
	    height = 28,
	    shift = util.by_pixel(0, 65),
	    variation_count = 1,
	    scale = 5
	  },
	  rotate = false,
	  orientation_to_variation = false
	}
},
-- TECHNOLOGY
{
	type = "technology",
	name = "roboport-bno",
	icon_size = 64,
	icon = "__brave-new-oarc__/graphics/icons/roboport-bno.png",
	effects =
	{
		{
			type = "unlock-recipe",
			recipe = "roboport-bno"
		}
	},
	prerequisites = {"robotics"},
	unit =
	{
		count = 500,
		ingredients =
		{
			{"automation-science-pack", 1},
			{"logistic-science-pack",   1},
			{"chemical-science-pack",   1}
		  },
		time = 60
	},
	order = "a-b-c"
},
-- RECIPE
{
	type = "recipe",
	name = "roboport-bno",
	icon_size = 64,
	icon = "__brave-new-oarc__/graphics/icons/roboport-bno.png",
	enabled = false,
	energy_required = 10,
	ingredients =
	{
		{ type="item", name="steel-plate", amount=10 },
		{ type="item", name="roboport", amount=4 },
		{ type="item", name="processing-unit", amount=10 }
	},
	-- 2.0 result = "roboport-bno"
	results = {{type="item", name="roboport-bno", amount=1}}
},
	-- ITEM
	{
		type = "item",
		name = "roboport-bno",
		icon = "__brave-new-oarc__/graphics/icons/roboport-bno.png",
		icon_size = 64,
		subgroup = "logistic-network",
		order = "c[signal]-a[roboport-bno]",
		inventory_move_sound = item_sounds.roboport_inventory_move,
		pick_sound = item_sounds.roboport_inventory_pickup,
		drop_sound = item_sounds.roboport_inventory_move,
		place_result = "roboport-bno",
		stack_size = 10,
		weight = 500*kg,
		random_tint_color = item_tints.iron_rust,
--		scale=.9
	},
})
